window.Gleam.initSearch([{"doc":"gleamql","title":"gleamql","content":"# gleamql\n\n[![Package Version](https://img.shields.io/hexpm/v/gleamql)](https://hex.pm/packages/gleamql)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gleamql/)\n\nSimple Graphql Client Written In Gleam ✨\n\n## Installation\n\n```gleam\nimport gleamql\nimport gleam/json.{string}\nimport gleam/dynamic.{field}\n\npub type Data {\n  Data(country: Country)\n}\n\npub type Country {\n  Country(name: String)\n}\n\npub fn main() {\n  assert Ok(resp) =\n    gleamql.new()\n    |&gt; gleamql.set_query(\n      &quot;query CountryQuery($code: ID!) {\n  country(code: $code) {\n    name\n  }\n}&quot;,\n    )\n    |&gt; gleamql.set_variable(&quot;code&quot;, string(&quot;GB&quot;))\n    |&gt; gleamql.set_host(&quot;countries.trevorblades.com&quot;)\n    |&gt; gleamql.set_path(&quot;/graphql&quot;)\n    |&gt; gleamql.set_header(&quot;Content-Type&quot;, &quot;application/json&quot;)\n    |&gt; gleamql.send()\n\n  assert Ok(data) =\n    dynamic.decode1(\n      Data,\n      field(\n        &quot;country&quot;,\n        of: fn(country) {\n          dynamic.decode1(Country, field(&quot;name&quot;, of: dynamic.string))(country)\n        },\n      ),\n    )(\n      resp,\n    )\n\n  assert &quot;United Kingdom&quot; = data.country.name\n}\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add gleamql\n```\n\nand its documentation can be found at &lt;https://hexdocs.pm/gleamql&gt;.\n","url":"index.html"},{"doc":"gleamql","title":"GraphQLError","content":"pub type GraphQLError {\n  ErrorMessage(message: String)\n  UnexpectedStatus(status: Int)\n  UnrecognisedResponse(response: String)\n  UnknownError(inner: Dynamic)\n}\n\nErrorMessage(message: String)\n\n\nUnexpectedStatus(status: Int)\n\n\nUnrecognisedResponse(response: String)\n\n\nUnknownError(inner: Dynamic)\n\n\nSynonyms:\ngleamql.GraphQLError\ngleamql GraphQLError","url":"gleamql.html#GraphQLError"},{"doc":"gleamql","title":"Request","content":"pub type Request {\n  Request(\n    http_request: request.Request(String),\n    query: Option(String),\n    variables: Option(List(#(String, Json))),\n  )\n}\n\nRequest(\n  http_request: request.Request(String),\n  query: Option(String),\n  variables: Option(List(#(String, Json))),\n)\n\n\nSynonyms:\ngleamql.Request\ngleamql Request","url":"gleamql.html#Request"},{"doc":"gleamql","title":"new","content":"pub fn new() -&gt; Request\n\nSynonyms:\ngleamql.new\ngleamql new","url":"gleamql.html#new"},{"doc":"gleamql","title":"send","content":"pub fn send(req: Request) -&gt; Result(Dynamic, GraphQLError)\n\nSynonyms:\ngleamql.send\ngleamql send","url":"gleamql.html#send"},{"doc":"gleamql","title":"set_header","content":"pub fn set_header(req: Request, key: String, value: String) -&gt; Request\n\nSynonyms:\ngleamql.set_header\ngleamql set_header","url":"gleamql.html#set_header"},{"doc":"gleamql","title":"set_host","content":"pub fn set_host(req: Request, host: String) -&gt; Request\n\nSynonyms:\ngleamql.set_host\ngleamql set_host","url":"gleamql.html#set_host"},{"doc":"gleamql","title":"set_path","content":"pub fn set_path(req: Request, path: String) -&gt; Request\n\nSynonyms:\ngleamql.set_path\ngleamql set_path","url":"gleamql.html#set_path"},{"doc":"gleamql","title":"set_query","content":"pub fn set_query(req: Request, query: String) -&gt; Request\n\nSynonyms:\ngleamql.set_query\ngleamql set_query","url":"gleamql.html#set_query"},{"doc":"gleamql","title":"set_variable","content":"pub fn set_variable(req: Request, key: String, value: Json) -&gt; Request\n\nSynonyms:\ngleamql.set_variable\ngleamql set_variable","url":"gleamql.html#set_variable"},{"doc":"gleamql","title":"gleamql","content":"","url":"gleamql.html"}]);